#include <Wire.h>
#include <Adafruit_MCP4725.h>
//#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
Adafruit_MCP4725 dac0;
//Adafruit_MCP4725 dac;
#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);
word aku = 0;
word akim = 0;
word mosfet = 0;
word besleme = 0;
float setgerilim = 0;
float setakim = 0;
word b = 0;
word a = 0;
float voltage = 0;
int setValue = 0;
const byte ak = A0;
const byte mos = A1;
const byte bes = A2;
void setup (void) {
  Serial.begin(9600);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3D (for the 128x64)
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.display();
  delay(1);
  dac0.begin(0x62);
  setValue = voltage;
  dac0.setVoltage(setValue, false);
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(6, INPUT_PULLUP);
  delay(100);
}
void loop (void) {
  // int aa = digitalRead(2);
  int yuk = digitalRead(6);
  int as = digitalRead(5);
  int sol = digitalRead(3);
  int sag = digitalRead(4);
  akim = analogRead(ak);
  mosfet = analogRead(mos);
  besleme = analogRead(bes);
  aku = besleme - mosfet;

  if ( mosfet > (besleme - 5)) {
    voltage = 0;
    setValue = voltage;
    dac0.setVoltage(setValue, false);
    aku = 0;
    display.setCursor(40, 0);
    display.setTextColor(BLACK, WHITE);
    display.println("AKU BOZUK");
    display.setCursor(0, 17);
    display.setTextColor(WHITE);
    display.println("V:");
    display.setCursor(0, 34);
    display.println("A:");
    display.setCursor(17, 12);
    display.setTextSize(2);
    display.print((setgerilim / 25.6), 1);
    display.setCursor(72, 12);
    display.print((aku / 25.6), 1);
    display.setCursor(17, 35);
    display.print((setakim / 45.056), 1);
    display.setCursor(72, 35);
    display.print((akim / 45.056), 1);
    display.setCursor(0, 55);
    display.setTextSize(1);
    display.print(voltage, 0);
    display.setCursor(50, 55);
    display.print(a);
    display.setCursor(90, 55);
    display.print(b);
    display.display();
    delay(100);
    loop();
  }
  if (yuk == 0) {
    setgerilim = setgerilim + 2.56;
  }
  if (as == 0) {
    setgerilim = setgerilim - 2.56;
    if (setgerilim < 0) {
      setgerilim = 0;
    }
  }
  if (sag == 0) {
    setakim = setakim + 4.5056;
  }
  if (sol == 0) {
    setakim = setakim - 4.5056;
    if (setakim < 0) {
      setakim = 0;
    }
  }
  if (setakim > 10240) {
    setakim = 0;
  }
  if (setgerilim > 10240) {
    setgerilim = 0;
  }

  if (setgerilim > aku) {
    if (akim < (setakim)) {
      a = setakim - akim;
      voltage = voltage + a;
    }

    if (akim > setakim) {
      b = akim - setakim;
      voltage = voltage - b;
    }
  }
  if (setgerilim < aku) {
    if (setgerilim > 2) {
      voltage = voltage - 1;
    }
  }
  if (aku > (besleme - 10) ) {
    voltage = 0;
  }
  if (voltage > 4095) {
    voltage = 4095 ;
  }
  if (voltage < 0) {
    voltage = 0;
  }
  if (setakim > 10000) {
    voltage = 0;
  }
  if (setakim < 4.5056) {
    voltage = 0;
  }
  setValue = voltage;
  dac0.setVoltage(setValue, false);
  display.clearDisplay();
  display.setCursor(30, 0);
  display.println("SET");
  display.setCursor(80, 0);
  display.println("REAL");
  display.setCursor(0, 17);
  display.println("V:");
  display.setCursor(0, 34);
  display.println("A:");
  display.setCursor(17, 12);
  display.setTextSize(2);
  display.print((setgerilim / 25.6), 1);
  display.setCursor(72, 12);
  display.print((aku / 25.6), 1);
  display.setCursor(17, 35);
  display.print((setakim / 45.056), 1);
  display.setCursor(72, 35);
  display.print((akim / 45.056), 1);
  display.setCursor(0, 55);
  display.setTextSize(1);
  display.print(voltage, 0);
  display.setCursor(50, 55);
  display.print(a);
  display.setCursor(90, 55);
  display.print(b);
  // display.print(a);display.print(" ");display.print(b);
  display.display();
  delay(150);
}
